package Pack;

import lejos.hardware.Brick;
import lejos.hardware.BrickFinder;
import lejos.hardware.Button;
import lejos.hardware.Sound;
import lejos.hardware.lcd.LCD;
import lejos.hardware.motor.Motor;
import lejos.hardware.port.Port;
import lejos.hardware.sensor.EV3ColorSensor;
import lejos.robotics.navigation.MovePilot;
import lejos.utility.Delay;


//my puppy 22222222222222222222222222222222222222222222
public class puppy {

	
	public static byte NUMBER_ACTIONS = 3;
	public static byte NUMBER_STATES = 4;
	
	static MovePilot pilot;
	static Sensor color;
	
	byte motorCommand = 0;
	
	static QTools Q = new QTools(NUMBER_ACTIONS, NUMBER_STATES);
	private static EV3ColorSensor sensor3;
	
	@SuppressWarnings("deprecation")
	
	public static void main(String[] args) {
	
		Brick brick1 = BrickFinder.getDefault();
		Port s3 = (Port)brick1.getPort("S3");
		sensor3 = new EV3ColorSensor(s3);
		color = new Sensor(sensor3.getColorIDMode());  
		
		byte env = -1;
		
		// No1
		Motor.D.setSpeed(300);
		Motor.D.rotate(60);
		Motor.D.rotate(-60);
		Motor.B.setSpeed(80);	
		Motor.B.forward();
		Delay.msDelay(3000);
		Motor.A.setSpeed(200);
		Motor.A.rotate(360);
		
		
		while(Button.ESCAPE.isUp())	{

			Delay.msDelay(50);
			env = getEnvironment();//color.presseds
			
			if(env != -1){
				
				//Motor.A
				//
				byte a = Q.getAction(env);
				float r = Q.reward(env, a);
				writeMess("Color & Action", "Reward = ", env, a, r);
				byte command = Q.getCommand(a);

				
				Motor.A.stop();
				Motor.B.stop();
				Delay.msDelay(2000);					
				
				puppyCommands(command);
					
				Motor.B.setSpeed(80);
				Motor.B.forward();
				Motor.A.setSpeed(200);
				Motor.A.rotate(360);
								
			}
		}
		exit();

	}
	
	
	/* Void instruction for closing the program safely
	 * Also closing the used sensors.
	 */
	public static void exit(){ // Please insert the amount of sensors used
		Motor.B.stop();
		pilot.stop();
		sensor3.close();
		System.exit(0);
		
	}
	
	
	// Functions that Stores actions the robot can take.
	public static void puppyCommands(byte command){
		
		switch(command){
		
		case 0: //right drop <- red
			Motor.D.setSpeed(300);
			Motor.D.rotate(45);

			Motor.B.setSpeed(160);
			Motor.B.forward();

			Delay.msDelay(2000);

			Motor.B.stop();
			Motor.D.rotate(-45);			
			break;
			
		case 1: //left drop <- blue color
			Motor.D.setSpeed(300);
			Motor.D.rotate(-45);

			Motor.B.setSpeed(160);
			Motor.B.forward();

			Delay.msDelay(2000);

			Motor.B.stop();
			Motor.D.rotate(45);			
			break;
			
		case 2://pass <- yellow	
			Motor.D.setSpeed(300);
			Motor.D.rotate(100);
			Motor.B.setSpeed(150);
			Motor.B.forward();
			Delay.msDelay(3200);
			Motor.D.rotate(-100);			
			break;
			
		}
		
	}
	
	public static byte getEnvironment(){
		
		byte colorSensor = color.pressed();
		return colorSensor;
		
	}
	
	public static void writeMess(String mess1, String mess2, int val1, int val2, float val3){
		
		LCD.clear();
		
		//LCD.drawstring(,xW,yW)
		LCD.drawString(mess1, 2, 1); LCD.drawInt(val1, 4, 2); LCD.drawInt(val2, 12, 2);
		LCD.drawString(mess2, 2, 4); LCD.drawInt((int)(val3*100), 11, 4);
		
		for(int i=0;i<2; i++){
				LCD.drawInt((int)(Q.Q[i][0]*10.0), i+4, 6); 				
		}
		for(int i=0;i<2; i++){
			LCD.drawInt((int)(Q.Q[i][1]*10.0), i+4, 7); 				
		}
		
		//LCD.drawString("L.R = ", 1, 6); LCD.drawInt((int)(QTools.LEARN_RATE*100), 6, 6);
		//LCD.drawString("E.R = ", 10, 6); LCD.drawInt((int)(EXPLORE_RATE*100), 15, 6);
		
	}

}
